var express = require('express');
var router = express.Router();

/* GET home page. */
router.get("/", function(req, res, next) {
  res.render("index", { title: "Search JS : Rechercher du JavaScript", h1: "Rechercher du JavaScript" });
});

/* Appel GET sur la page /about */
router.get("/about", function(req, res, next) {
  res.render("about", { title: "A propos de Search JS", h1: "A propos de l'application" });
});

/* Appel GET/POST sur la page de recherche */
router.all("/search", function(req, res, next) {
  var motcle=req.query.motcle.trim().toLowerCase();
  motcle=motcle.replace(/(<([^>]+)>)/ig,""); /* Supprime les tags HTML */
  /* Rechercher le mot clé dans la base JSON */
  var results=[];
  if (motcle.length>=2) { /* Il y a un mot clé d'au moins 2 caractères*/
    /* Chargement de la base de données des fiches au format JSON */
    var fiches=require("../data/fiches.json");
    /* Parcourir toutes les fiches pour trouver le mot clé */
    for (var i=0; i<fiches.length; i++) {
      if (fiches[i].name.toLowerCase().indexOf(motcle)>=0) {
        results.push(fiches[i]); /* Fiche si elle correspond au mot clé */
      }
    }
    /* Affichage du template search.js avec les résultats de recherche */
    res.render("search",
      { title: "Résultats de recherche",
        h1: "Rechercher du JavaScript",
        motcle: motcle,
        results: results
      }
    );
  }
});

module.exports = router;